SimpleHttpServerFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.remoting.support

## Class SimpleHttpServerFactoryBean

- java.lang.Object
- - org.springframework.remoting.support.SimpleHttpServerFactoryBean

- All Implemented Interfaces:
    DisposableBean, FactoryBean<com.sun.net.httpserver.HttpServer>, InitializingBean

      public class SimpleHttpServerFactoryBean
      extends Object
      implements FactoryBean<com.sun.net.httpserver.HttpServer>, InitializingBean, DisposableBean

  `FactoryBean` that creates a simple HTTP server, based on the HTTP server that is included in Sun's JRE 1.6. Starts the HTTP server on initialization and stops it on destruction. Exposes the resulting `HttpServer` object.

  Allows for registering `HttpHandlers` for specific `context paths`. Alternatively, register such context-specific handlers programmatically on the `HttpServer` itself.

  Since:
    2.5.1
  Author:
    Juergen Hoeller, Arjen Poutsma
  See Also:
    `setPort(int)`, `setContexts(java.util.Map<java.lang.String, com.sun.net.httpserver.HttpHandler>)`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Log` | `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleHttpServerFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `void` | `destroy()` Invoked by a BeanFactory on destruction of a singleton.
    `com.sun.net.httpserver.HttpServer` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends com.sun.net.httpserver.HttpServer>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setAuthenticator(com.sun.net.httpserver.Authenticator authenticator)` Register a common `Authenticator` to be applied to all locally registered `contexts`.
    `void` | `setBacklog(int backlog)` Specify the HTTP server's TCP backlog.
    `void` | `setContexts(Map<String,com.sun.net.httpserver.HttpHandler> contexts)` Register `HttpHandlers` for specific context paths.
    `void` | `setExecutor(Executor executor)` Set the JDK concurrent executor to use for dispatching incoming requests.
    `void` | `setFilters(List<com.sun.net.httpserver.Filter> filters)` Register common `Filters` to be applied to all locally registered `contexts`.
    `void` | `setHostname(String hostname)` Specify the HTTP server's hostname to bind to.
    `void` | `setPort(int port)` Specify the HTTP server's port.
    `void` | `setShutdownDelay(int shutdownDelay)` Specify the number of seconds to wait until HTTP exchanges have completed when shutting down the HTTP server.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### logger

          protected final Log logger

  - ### Constructor Detail

    - #### SimpleHttpServerFactoryBean

          public SimpleHttpServerFactoryBean()

  - ### Method Detail

    - #### setPort

          public void setPort(int port)

      Specify the HTTP server's port. Default is 8080.

    - #### setHostname

          public void setHostname(String hostname)

      Specify the HTTP server's hostname to bind to. Default is localhost; can be overridden with a specific network address to bind to.

    - #### setBacklog

          public void setBacklog(int backlog)

      Specify the HTTP server's TCP backlog. Default is -1, indicating the system's default value.

    - #### setShutdownDelay

          public void setShutdownDelay(int shutdownDelay)

      Specify the number of seconds to wait until HTTP exchanges have completed when shutting down the HTTP server. Default is 0.

    - #### setExecutor

          public void setExecutor(Executor executor)

      Set the JDK concurrent executor to use for dispatching incoming requests.
      See Also:
        `HttpServer.setExecutor(java.util.concurrent.Executor)`

    - #### setContexts

          public void setContexts(Map<String,com.sun.net.httpserver.HttpHandler> contexts)

      Register `HttpHandlers` for specific context paths.
      Parameters:
        `contexts` - a Map with context paths as keys and HttpHandler objects as values
      See Also:
        `SimpleHttpInvokerServiceExporter`, `SimpleHessianServiceExporter`, `SimpleBurlapServiceExporter`

    - #### setFilters

          public void setFilters(List<com.sun.net.httpserver.Filter> filters)

      Register common `Filters` to be applied to all locally registered `contexts`.

    - #### setAuthenticator

          public void setAuthenticator(com.sun.net.httpserver.Authenticator authenticator)

      Register a common `Authenticator` to be applied to all locally registered `contexts`.

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws IOException

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Throws:
        `IOException`

    - #### getObject

          public com.sun.net.httpserver.HttpServer getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<com.sun.net.httpserver.HttpServer>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends com.sun.net.httpserver.HttpServer> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<com.sun.net.httpserver.HttpServer>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<com.sun.net.httpserver.HttpServer>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

    - #### destroy

          public void destroy()

      Description copied from interface: `DisposableBean`
      Invoked by a BeanFactory on destruction of a singleton.
      Specified by:
        `destroy` in interface `DisposableBean`